/*  "blkio.scm" WB-tree File Based Associative String Data Base System. */
/*  Copyright (C) 1991, 1992, 1993, 2000, 2003 Free Software Foundation, Inc. */
/*  */
/*  This program is free software; you can redistribute it and/or modify */
/*  it under the terms of the GNU General Public License as published by */
/*  the Free Software Foundation; either version 2, or (at your option) */
/*  any later version. */
/*  */
/*  This program is distributed in the hope that it will be useful, */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*  GNU General Public License for more details. */
/*  */
/*  You should have received a copy of the GNU General Public License */
/*  along with this software; see the file COPYING.  If not, write to */
/*  the Free Software Foundation, 59 Temple Place, Suite 330, Boston, */
/*  MA 02111, USA. */
/*  */
/*  As a special exception, the Free Software Foundation gives permission */
/*  for additional uses of the text contained in its release of WB. */
/*  */
/*  The exception is that, if you link the WB library with other files */
/*  to produce an executable, this does not by itself cause the */
/*  resulting executable to be covered by the GNU General Public License. */
/*  Your use of that executable is in no way restricted on account of */
/*  linking the WB library code into it. */
/*  */
/*  This exception does not however invalidate any other reasons why */
/*  the executable file might be covered by the GNU General Public License. */
/*  */
/*  This exception applies only to the code released by the */
/*  Free Software Foundation under the name WB.  If you copy */
/*  code from other Free Software Foundation releases into a copy of */
/*  WB, as the General Public License permits, the exception does */
/*  not apply to the code that you add in this way.  To avoid misleading */
/*  anyone as to the status of such modified files, you must delete */
/*  this exception notice from them. */
/*  */
/*  If you write modifications of your own for WB, it is your choice */
/*  whether to permit this exception to apply to your modifications. */
/*  If you do not wish that, delete this exception notice. */

/*  routines in this file return pass/fail (#t/#f) */




package wb;

import static wb.Ents.*;
import static wb.Scan.*;
import static wb.Prev.*;
import static wb.Stats.*;
import static wb.Blink.*;
import static wb.Del.*;
import static wb.Segs.*;
import static wb.Handle.*;
import static wb.Wbdefs.*;
import static wb.Wbsys.*;
import static wb.Blk.*;
import static wb.BooleanMethods.*;
import static wb.Pkt.*;
import static wb.Ent.*;
import static wb.Seg.*;
import static wb.Db.*;
public class Blkio {


public static int ioDiag = 0;


public static void blkio_Init()
{
  
  return;
}


public static java.io.RandomAccessFile blkio_CreateFile(String name,int bsiz)
{
  return openOutputFile(name);
}


public static java.io.RandomAccessFile blkio_OpenModifyFile(String name,int bsiz)
{
  return openIoFile(name);
}


public static java.io.RandomAccessFile blkio_OpenReadOnlyFile(String name,int bsiz)
{
  return openInputFile(name);
}


public static int blkio_FileClose(java.io.RandomAccessFile file)
{
  return closePort(file);
}


public static int blkio_Read(java.io.RandomAccessFile file,byte []blk,int bsiz,int blknum)
{
  filePosition(file, (bsiz)*(blknum));
  if ((bsiz)==(subbytesRead(blk, 0, bsiz, file)))
    {
      if (a2b(ioDiag))
	dprintf("rd:"+(1+((blk_Level(blk))-(leaf)))+""+""+" "+(blk_Typ(blk))+"\n");
      if (blk_Typ_P(blk, frlTyp))
	{
	  readFlCt = (readFlCt)+1;
	}
      else readCt = (readCt)+1;
      return 1;
    }
  else {
    dprintf(">>>>ERROR<<<<  couldn\'t read blk "+(blknum)+"\n");
    return 0;
  }
}


public static int blkio_Write(java.io.RandomAccessFile file,byte []blk,int bsiz,int blknum)
{
  filePosition(file, (bsiz)*(blknum));
  if ((bsiz)==(subbytesWrite(blk, 0, bsiz, file)))
    {
      if (a2b(ioDiag))
	dprintf("wr:"+(1+((blk_Level(blk))-(leaf)))+""+""+" "+(blk_Typ(blk))+"\n");
      if (blk_Typ_P(blk, frlTyp))
	{
	  writeFlCt = (writeFlCt)+1;
	}
      else writeCt = (writeCt)+1;
      return 1;
    }
  else {
    dprintf(">>>>ERROR<<<<  couldn\'t write blk "+(blknum)+"\n");
    return 0;
  }
}


public static int blkio_FileExtend(java.io.RandomAccessFile file,byte []blk,int bsiz,int blknum)
{
  filePosition(file, (bsiz)*(blknum));
  if ((bsiz)==(subbytesWrite(blk, 0, bsiz, file)))
    {
      if (a2b(ioDiag))
	dprintf("Extending file "+(((flcLen)/2)+1)+" blks\n");
      return 1;
    }
  else {
    dprintf(">>>>ERROR<<<<  couldn\'t extend file "+(blknum)+"\n");
    return 0;
  }
}

}
