/*  "blkio.scm" WB-tree File Based Associative String Data Base System. */
/*  Copyright (C) 1991, 1992, 1993, 2000, 2003 Free Software Foundation, Inc. */
/*  */
/*  This program is free software; you can redistribute it and/or modify */
/*  it under the terms of the GNU General Public License as published by */
/*  the Free Software Foundation; either version 2, or (at your option) */
/*  any later version. */
/*  */
/*  This program is distributed in the hope that it will be useful, */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*  GNU General Public License for more details. */
/*  */
/*  You should have received a copy of the GNU General Public License */
/*  along with this software; see the file COPYING.  If not, write to */
/*  the Free Software Foundation, 59 Temple Place, Suite 330, Boston, */
/*  MA 02111, USA. */
/*  */
/*  As a special exception, the Free Software Foundation gives permission */
/*  for additional uses of the text contained in its release of WB. */
/*  */
/*  The exception is that, if you link the WB library with other files */
/*  to produce an executable, this does not by itself cause the */
/*  resulting executable to be covered by the GNU General Public License. */
/*  Your use of that executable is in no way restricted on account of */
/*  linking the WB library code into it. */
/*  */
/*  This exception does not however invalidate any other reasons why */
/*  the executable file might be covered by the GNU General Public License. */
/*  */
/*  This exception applies only to the code released by the */
/*  Free Software Foundation under the name WB.  If you copy */
/*  code from other Free Software Foundation releases into a copy of */
/*  WB, as the General Public License permits, the exception does */
/*  not apply to the code that you add in this way.  To avoid misleading */
/*  anyone as to the status of such modified files, you must delete */
/*  this exception notice from them. */
/*  */
/*  If you write modifications of your own for WB, it is your choice */
/*  whether to permit this exception to apply to your modifications. */
/*  If you do not wish that, delete this exception notice. */

/*  routines in this file return pass/fail (#t/#f) */



#include "wbsys.h"
#ifdef unix
# include <sys/types.h>
# include <sys/stat.h>
# include <fcntl.h>
# include <unistd.h>
#endif


int io_diag = 0;


void blkio_init()
{
  
  return;
}


int blkio_create_file(name, bsiz)
     unsigned char *name;
     int bsiz;
{
  return open_output_file(name);
}


int blkio_open_modify_file(name, bsiz)
     unsigned char *name;
     int bsiz;
{
  return open_io_file(name);
}


int blkio_open_read_only_file(name, bsiz)
     unsigned char *name;
     int bsiz;
{
  return open_input_file(name);
}


int blkio_file_close(file)
     int file;
{
  return close_port(file);
}


int blkio_read(file, blk, bsiz, blknum)
     int file;
     unsigned char *blk;
     int bsiz;
     long blknum;
{
  file_position(file, (bsiz)*(blknum));
  if ((bsiz)==(subbytes_read(blk, 0, bsiz, file)))
    {
      if (io_diag)
	dprintf((diagout, "rd:%*s%c %10ld\n", 1+((blk_level(blk))-(leaf)), "", blk_typ(blk), blknum));
      if (blk_typ_P(blk, frl_typ))
	{
	  read_fl_ct = (read_fl_ct)+0x1L;
	}
      else read_ct = (read_ct)+0x1L;
      return !0;
    }
  else {
    dprintf((diagout, ">>>>ERROR<<<<  couldn't read blk %ld\n", blknum));
    return 0;
  }
}


int blkio_write(file, blk, bsiz, blknum)
     int file;
     unsigned char *blk;
     int bsiz;
     long blknum;
{
  file_position(file, (bsiz)*(blknum));
  if ((bsiz)==(subbytes_write(blk, 0, bsiz, file)))
    {
      if (io_diag)
	dprintf((diagout, "wr:%*s%c %10ld\n", 1+((blk_level(blk))-(leaf)), "", blk_typ(blk), blknum));
      if (blk_typ_P(blk, frl_typ))
	{
	  write_fl_ct = (write_fl_ct)+0x1L;
	}
      else write_ct = (write_ct)+0x1L;
      return !0;
    }
  else {
    dprintf((diagout, ">>>>ERROR<<<<  couldn't write blk %ld\n", blknum));
    return 0;
  }
}


int blkio_file_extend(file, blk, bsiz, blknum)
     int file;
     unsigned char *blk;
     int bsiz;
     long blknum;
{
  file_position(file, (bsiz)*(blknum));
  if ((bsiz)==(subbytes_write(blk, 0, bsiz, file)))
    {
      if (io_diag)
	dprintf((diagout, "Extending file %d blks\n", ((flc_len)/2)+1));
      return !0;
    }
  else {
    dprintf((diagout, ">>>>ERROR<<<<  couldn't extend file %ld\n", blknum));
    return 0;
  }
}
