/* WB-tree File Based Associative String Data Base System.
* Copyright (C) 1991, 1992, 1993, 2000, 2003 Free Software Foundation, Inc.
* Copyright 2007 Clear Methods, Inc.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this software; see the file COPYING.  If not, write to
* the Free Software Foundation, 59 Temple Place, Suite 330, Boston, MA
* 02111, USA.
*
* As a special exception, the Free Software Foundation gives permission
* for additional uses of the text contained in its release of WB.
*
* The exception is that, if you link the WB library with other files
* to produce an executable, this does not by itself cause the
* resulting executable to be covered by the GNU General Public License.
* Your use of that executable is in no way restricted on account of
* linking the WB library code into it.
*
* This exception does not however invalidate any other reasons why
* the executable file might be covered by the GNU General Public License.
*
* This exception applies only to the code released by the
* Free Software Foundation under the name WB.  If you copy
* code from other Free Software Foundation releases into a copy of
* WB, as the General Public License permits, the exception does
* not apply to the code that you add in this way.  To avoid misleading
* anyone as to the status of such modified files, you must delete
* this exception notice from them.
*
* If you write modifications of your own for WB, it is your choice
* whether to permit this exception to apply to your modifications.
* If you do not wish that, delete this exception notice.
*/


public static FileStream openInputFile(string filename)
{
    FileStream file = new FileStream(filename, FileMode.OpenOrCreate, FileAccess.Read);
    return file;
}

public static FileStream openOutputFile(string filename)
{
    FileStream file = new FileStream(filename, FileMode.OpenOrCreate, FileAccess.Write);
    return file;
}

public static FileStream openIoFile(string filename)
{
    FileStream file = new FileStream(filename, FileMode.OpenOrCreate,FileAccess.ReadWrite);
    return file;
}

public static long filePosition(FileStream file)
{
    return file.Position;
}

public static long filePosition(FileStream file, long pos)
{
    long tmp = file.Position;
    file.Position = pos;
    return tmp;
}

public static int closePort(FileStream file)
{
    file.Close();
    return 1;
}

public static int subbytesWrite(byte[] buf, int start, int end, FileStream file)
{
    file.Write(buf, start, (end - start));
    return (end - start);
}

public static int subbytesRead(byte[] buf, int start, int end, FileStream file)
{
    file.Read(buf, start, (end - start));
    return (end - start);
}

public static bool outputPort_P(FileStream file)
{
    return file.CanWrite;
}

public static bool inputPort_P(FileStream file)
{
    return file.CanRead;
}

public static int min(int a, int b)
{
    return (a < b) ? a : b;
}

public static int max(int a, int b)
{
    return (a > b) ? a : b;
}

public static void dprintf(string str)
{
    Console.Error.Write(str);
}

public static void substringMove(byte[] src, int srcStart, int srcEnd, byte[] dest, int destStart)
{
    System.Array.Copy(src, srcStart, dest, destStart, (srcEnd - srcStart));
}

public static void substringMoveLeft(byte[] src, int srcStart, int srcEnd, byte[] dest, int destStart)
{
    System.Array.Copy(src, srcStart, dest, destStart, (srcEnd - srcStart));
}

public static void substringMoveRight(byte[] src, int srcStart, int srcEnd, byte[] dest, int destStart)
{
    System.Array.Copy(src, srcStart, dest, destStart, (srcEnd - srcStart));
}

public static byte[] subArray(byte[] src, int idx)
{
    byte[] dest = new byte[idx];
    System.Array.Copy(src, dest, idx);
    return dest;
}

public static byte[] stringToBytes(string str)
{
    if(str == null) return null;
    return Encoding.UTF8.GetBytes(str);
}

public static string bytesToString(byte[] bytes)
{
    if (bytes == null) return null;
    return Encoding.UTF8.GetString(bytes);
}

public static int time(byte[] b)
{
    return DateTime.Now.Millisecond;
}


public static Object resizeArray(Object[] old, int newLength)
{
    int upto = (old.Length < newLength) ? old.Length : newLength;
    Object[] newArray = new Object[upto];

    System.Array.Copy(old, newArray, upto);
    return newArray;
}

public static Type wbClass = typeof(wb);

// The invokeFunc definition is generated by scm2cs.
// It looks like this:
//
// public static int invokeFunc(String funcName, params Object[] args)
//	 {
//		 MethodInfo method = typeof(wb).GetMethod(funcName);
//		 return (int) method.Invoke(null, args);//first parameter is null for all static methods.
//	 }

public static byte[] bytes(params byte[] bArray)
{
    return bArray;
}

public static readonly byte[] longZero = new byte[16];

/* Boolean Methods*/
public static bool a2b(bool b) {return b;}
//public static bool a2b(byte i) {return (i!= 0);}
//public static bool a2b(short i) {return (i!= 0);}
public static bool a2b(int i) {return (i!= 0);}
//public static bool a2b(long i) {return (i!= 0);}
public static bool a2b(Object i) {return (i!= null);}
//public static bool a2b() {return true;}
