;; "example.scm" WB-tree File Based Associative String Data Base System.
;; Copyright (C) 1991, 1992, 1993, 2000 Free Software Foundation, Inc.
;;
;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this software; see the file COPYING.  If not, write to
;; the Free Software Foundation, 59 Temple Place, Suite 330, Boston,
;; MA 02111, USA.
;;
;; As a special exception, the Free Software Foundation gives permission
;; for additional uses of the text contained in its release of WB.
;;
;; The exception is that, if you link the WB library with other files
;; to produce an executable, this does not by itself cause the
;; resulting executable to be covered by the GNU General Public License.
;; Your use of that executable is in no way restricted on account of
;; linking the WB library code into it.
;;
;; This exception does not however invalidate any other reasons why
;; the executable file might be covered by the GNU General Public License.
;;
;; This exception applies only to the code released by the
;; Free Software Foundation under the name WB.  If you copy
;; code from other Free Software Foundation releases into a copy of
;; WB, as the General Public License permits, the exception does
;; not apply to the code that you add in this way.  To avoid misleading
;; anyone as to the status of such modified files, you must delete
;; this exception notice from them.
;;
;; If you write modifications of your own for WB, it is your choice
;; whether to permit this exception to apply to your modifications.
;; If you do not wish that, delete this exception notice.


;;;	       MUMPS Style Database Phone Book Example

(require 'wb)
(make-seg 5 "mydata" 2048)
(open-seg 5 "mydata" 2)			;opens a previously created segment.
(define pb (create-db 5 #\T "phone-book")) ;create an array called
					;"phone-book" which will
					;contain the phone book
					;records.
(define pi (create-db 5 #\T "phone-index"))	;create an array called
					;"phone-index" which we will
					;use for indexing by phone
					;number.
(define lni (create-db 5 #\T "lastname-index"))
					;create an array called
					;"lastname-index" which we will
					;use for indexing by last name
(define record-number 0)

;;;MAKE-NAME is a routine which concatenates its arguments together
;;;separated by control characters.  This assures that the arguments act
;;;as independent subscripts.
(define (make-name arg1 . args)
  (apply string-append
	 (if (number? arg1) (number->string arg1) arg1)
	 (apply append
		(map (lambda (arg)
		       (cond ((equal? "" arg) (list stringofnull))
			     ((number? arg)
			      (set! arg (number->string arg))
			      (list (string (integer->char
					     (min 30 (string-length arg))))
				    arg))
			     (else (list (string (integer->char 30)) arg))))
		     args))))


(bt:put! pb (make-name record-number "LN") "Doe") ;last name
(bt:put! pb (make-name record-number "FN") "Joe") ;first name
(bt:put! pb (make-name record-number "PN") "5551212") ;phone number
(bt:put! pb (make-name record-number "AD1") "13 Hi St.") ;street address
(bt:put! pb (make-name record-number "CITY") "Podunk")
(bt:put! pb (make-name record-number "ST") "NY")
(bt:put! pb (make-name record-number "ZIP") "10000")
(bt:put! lni (make-name "Doe" record-number) "")
					;This adds index entry so that
					;(bt:next lni (make-name "Doe"))
					;will find the record with
					;complete information.
(bt:put! pi (make-name "5551212" record-number) "")
					;similarly for looking up by
					;phone number.

;;; Note we put the record number into the key.  This is so that we
;;; can index records for more than one "Doe".

;(define doe-rec
;  (get-subscript
;   (bt:next lni (make-name "Doe"))		;returns the a name which
;   2))					;includes the record number of
					;the record.

;(bt:get pb (make-name doe-rec "PN"))	;returns Doe's Phone number.

(bt:scan pb 0 "" "zz" (lambda (k v) (print k v) #t) -1)

(close-seg 5 0)
