/* Test speed of WB-tree File Based Associative String Data Base System. */
/* Copyright 2007 Clear Methods, Inc. */

import static wb.Db.*;
import static wb.Segs.*;
import static wb.Handle.*;
import  wb.Han;

class Benchmark {

    public static void run() {
	makeSeg(6, "abcd", 2048);
	openSeg(6, "abcd", 2);

	Han db = createDb(6, 10, "randomdata");

	//Make Strings
	int numStrings = 10000;
	String[] str = new String [numStrings];
	//String[] str2 = new String [numStrings];

	for (int i = 0; i < numStrings; i++) {
	    str[i] = "string" + i;
	    //str2[i] = i + "string";
	}

	long sTime, eTime;
	final int million = 1000 * 1000;

	int loops = 10;

	int loopCount = 0;
	while(loopCount++ < loops) {
	    System.out.println("\nIteration " + loopCount);

	    sTime = System.nanoTime();
	    for(int i=0; i<numStrings; i++)
		bt_Put(db, str[i], str[i]);
	    eTime = System.nanoTime();

	    System.out.println("Time taken for " + numStrings + " insertions is " +
			       (double)(eTime - sTime)/million + " milli sec");
	    //System.out.println("Number of insertions per sec is "
	    //	      + (double) million * 1000 / (eTime - sTime));

	    sTime = System.nanoTime();
	    for(int i=0; i<numStrings; i++)
		//System.out.println(bt_Get(db, a+="a"));
		bt_Get(db, str[i]);
	    eTime = System.nanoTime();

	    System.out.println("Time taken for " + numStrings + " retrievals is " +
			       (double)(eTime - sTime)/million + " milli sec");
	    //System.out.println("Number of retrievals per sec is "
	    //	      + (double) million * 1000 / (eTime - sTime));

	    sTime = System.nanoTime();
	    for(int i = 0; i<numStrings; i++) {
		bt_Rem(db, str[i]);
	    }
	    eTime = System.nanoTime();

	    System.out.println("Time taken for " + numStrings + " deletes is " +
			       (double)(eTime - sTime)/million + " milli sec");
	    //System.out.println("Number of deletions per sec is "
	    //	      + (double) million * 1000 / (eTime - sTime));
	}
    }

    public static void main(String[] args) {
	run();
    }
}
