/* WB-tree File Based Associative String Data Base System.
 * Copyright (C) 1991, 1992, 1993, 2000, 2003 Free Software Foundation, Inc.
 * Copyright 2007 Clear Methods, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place, Suite 330, Boston, MA
 * 02111, USA.
 *
 * As a special exception, the Free Software Foundation gives permission
 * for additional uses of the text contained in its release of WB.
 *
 * The exception is that, if you link the WB library with other files
 * to produce an executable, this does not by itself cause the
 * resulting executable to be covered by the GNU General Public License.
 * Your use of that executable is in no way restricted on account of
 * linking the WB library code into it.
 *
 * This exception does not however invalidate any other reasons why
 * the executable file might be covered by the GNU General Public License.
 *
 * This exception applies only to the code released by the
 * Free Software Foundation under the name WB.  If you copy
 * code from other Free Software Foundation releases into a copy of
 * WB, as the General Public License permits, the exception does
 * not apply to the code that you add in this way.  To avoid misleading
 * anyone as to the status of such modified files, you must delete
 * this exception notice from them.
 *
 * If you write modifications of your own for WB, it is your choice
 * whether to permit this exception to apply to your modifications.
 * If you do not wish that, delete this exception notice.
 */
package wb;
import static wb.Ents.*;

public class Ent {
    public static Ent makeEntry() {
	return new Ent();
    }

    public static Ent ent_MakeEnt(int tag)
    {
	//System.out.println("blkSize = " + blkSize);
	Ent ent = new Ent();
	ent.TAG = tag;
	ent.SEG = -1;
	ent.ID  = -1;
	ent.BLK = new byte[blkSize];
	return ent;
    }

    //The getter methods in C take struct entry as a parameter.
    // Here we use object methods, thus the function ent_tag(ent)
    //in C appears as ent.entTag() in Java.
    public static int ent_Tag(Ent entry)
    {
	return entry.TAG;
    }

    public  static Ent ent_Next(Ent entry)
    {
	return entry.NEXT;
    }

    public static int ent_Seg(Ent entry)
    {
	return entry.SEG;
    }

    public static int ent_Id(Ent entry)
    {
	return entry.ID;
    }

    public static byte[] ent_Blk(Ent entry)
    {
	return entry.BLK;
    }

    public static int ent_Age(Ent entry)
    {
	return entry.AGE;
    }

    public static boolean ent_Dty_P(Ent entry)
    {
	return entry.DTY;
    }

    public static int ent_Pus(Ent entry)
    {
	return entry.PUS;
    }

    public static int ent_Acc(Ent entry)
    {
	return entry.ACC;
    }

    public static int ent_Ref(Ent entry)
    {
	return entry.REF;
    }
    //As with getter methods, we do not take  ry object as parameter,
    //but invoke methods on the objects.

    public static void ent_SetTag(Ent entry, int tag)
    {
	entry.TAG = tag;
    }

    public static void ent_SetNext(Ent entry, Ent next)
    {
	entry.NEXT = next;
    }

    public static void ent_SetSeg(Ent entry, int seg)
    {
	entry.SEG = seg;
    }

    public static void ent_SetId(Ent entry, int num)
    {
	entry.ID = num;
    }

    public static void ent_SetAge(Ent entry, int age)
    {
	entry.AGE = age;
    }

    public static void ent_SetDty(Ent entry, Object A){//for handling nulls.
        entry.DTY = ((A==null)? false:true);
    }

    public static void ent_SetDty(Ent entry, boolean dty)
    {
        entry.DTY = dty;
    }

    public static void ent_SetPus(Ent entry, int pus)
    {
	entry.PUS = pus;
    }

    public static void ent_SetAcc(Ent entry, int acc)
    {
	entry.ACC = acc;
    }

    public static void ent_SetRef(Ent entry, int ref)
    {
	entry.REF = ref;
    }

    public Ent NEXT;
    public int ID;
    public byte[] BLK;
    public boolean DTY;
    public int TAG, AGE,  PUS, ACC, REF, SEG;
}
