/* WB-tree File Based Associative String Data Base System.
 * Copyright (C) 1991, 1992, 1993, 2000, 2003 Free Software Foundation, Inc.
 * Copyright 2007 Clear Methods, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place, Suite 330, Boston, MA
 * 02111, USA.
 *
 * As a special exception, the Free Software Foundation gives permission
 * for additional uses of the text contained in its release of WB.
 *
 * The exception is that, if you link the WB library with other files
 * to produce an executable, this does not by itself cause the
 * resulting executable to be covered by the GNU General Public License.
 * Your use of that executable is in no way restricted on account of
 * linking the WB library code into it.
 *
 * This exception does not however invalidate any other reasons why
 * the executable file might be covered by the GNU General Public License.
 *
 * This exception applies only to the code released by the
 * Free Software Foundation under the name WB.  If you copy
 * code from other Free Software Foundation releases into a copy of
 * WB, as the General Public License permits, the exception does
 * not apply to the code that you add in this way.  To avoid misleading
 * anyone as to the status of such modified files, you must delete
 * this exception notice from them.
 *
 * If you write modifications of your own for WB, it is your choice
 * whether to permit this exception to apply to your modifications.
 * If you do not wish that, delete this exception notice.
 */
package wb;
import java.util.concurrent.atomic.*;
import static wb.Wbsys.*;

//This implementation works only with Java 5 and beyond.
public class Lck {

    public static Lck makeLck(int name)
    {
	Lck lk = new Lck();
	lk.next = lastLck;
	lk.flg =  new AtomicInteger();
	lk.name = name;
	lastLck = lk;
	return lk;
    }

    public static boolean tryLck_P(Lck lk)
    {
	if (lk.flg.decrementAndGet() > 0) return false;
	return true;
    }

    public static void lck(Lck lk)
    {
	if (lk.flg.decrementAndGet() > 0)
	    dprintf(">>>>ERROR<<<< spinning on lck " + lk.name);
    }

    public static void unlck(Lck lk)
    {
	if (lk.flg.get() == 0)
	    dprintf(">>>>ERROR<<<< unlcking unlck "+ lk.name);
	lk.flg.set(0);
    }

    public static void checkLcks()
    {
	Lck lck = lastLck;
	while (lck!=null) {
	    if (lck.flg.get()!=0) {
		if (lck.name < 0)
		    switch (lck.name) {
		    case -1:
			dprintf(">>>>ERROR<<<< free-ent-lck left lcked\n");
			break;
		    case -2:dprintf(">>>>ERROR<<<< flush-buk-lck left lcked\n");
			break;
		    default:
			dprintf(">>>>ERROR<<<< unknown lck left lcked\n");
		    }
		else
		    dprintf(">>>>ERROR<<<< lck " + lck.name + "  left lcked\n");
		lck.flg.set(0);
	    }
	    lck = lck.next;
	}
    }

    Lck next;
    static Lck lastLck;
    AtomicInteger flg;
    int name;
}
