/*  "stats.scm" WB-tree File Based Associative String Data Base System. */
/*  Copyright (C) 1991, 1992, 1993, 2000 Free Software Foundation, Inc. */
/*  */
/*  This program is free software; you can redistribute it and/or modify */
/*  it under the terms of the GNU General Public License as published by */
/*  the Free Software Foundation; either version 2, or (at your option) */
/*  any later version. */
/*  */
/*  This program is distributed in the hope that it will be useful, */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*  GNU General Public License for more details. */
/*  */
/*  You should have received a copy of the GNU General Public License */
/*  along with this software; see the file COPYING.  If not, write to */
/*  the Free Software Foundation, 59 Temple Place, Suite 330, Boston, */
/*  MA 02111, USA. */
/*  */
/*  As a special exception, the Free Software Foundation gives permission */
/*  for additional uses of the text contained in its release of WB. */
/*  */
/*  The exception is that, if you link the WB library with other files */
/*  to produce an executable, this does not by itself cause the */
/*  resulting executable to be covered by the GNU General Public License. */
/*  Your use of that executable is in no way restricted on account of */
/*  linking the WB library code into it. */
/*  */
/*  This exception does not however invalidate any other reasons why */
/*  the executable file might be covered by the GNU General Public License. */
/*  */
/*  This exception applies only to the code released by the */
/*  Free Software Foundation under the name WB.  If you copy */
/*  code from other Free Software Foundation releases into a copy of */
/*  WB, as the General Public License permits, the exception does */
/*  not apply to the code that you add in this way.  To avoid misleading */
/*  anyone as to the status of such modified files, you must delete */
/*  this exception notice from them. */
/*  */
/*  If you write modifications of your own for WB, it is your choice */
/*  whether to permit this exception to apply to your modifications. */
/*  If you do not wish that, delete this exception notice. */


#include "wbsys.h"

/*  PERFORMANCE STATISTICS */


long next_ct = 0;

long next_fct = 0;

long prev_ct = 0;

long prev_fct = 0;

long get_ct = 0;

long get_fct = 0;

long put_ct = 0;

long put_fct = 0;

long rem_ct = 0;

long rem_fct = 0;

long ge_ct = 0;

long ge_fct = 0;

long tge_ct = 0;

long tge_fct = 0;

long tce_ct = 0;

long tce_fct = 0;


int chains_to_next = 0;

int deferred_inserts = 0;

int split_index_inserts = 0;

int index_screw_case = 0;

int block_splits = 0;

int block_deletes = 0;

int deferred_deletes = 0;

long dir_dty_ct = 0;


long read_ct = 0;

long write_ct = 0;

long read_fl_ct = 0;

long write_fl_ct = 0;

long flush_ct = 0;


int clear_stats()
{
  next_ct = 0x0L;
  next_fct = 0x0L;
  prev_ct = 0x0L;
  prev_fct = 0x0L;
  get_ct = 0x0L;
  get_fct = 0x0L;
  put_ct = 0x0L;
  put_fct = 0x0L;
  rem_ct = 0x0L;
  rem_fct = 0x0L;
  ge_ct = 0x0L;
  ge_fct = 0x0L;
  tge_ct = 0x0L;
  tge_fct = 0x0L;
  tce_ct = 0x0L;
  tce_fct = 0x0L;
  chains_to_next = 0;
  deferred_inserts = 0;
  split_index_inserts = 0;
  index_screw_case = 0;
  block_splits = 0;
  block_deletes = 0;
  deferred_deletes = 0;
  dir_dty_ct = 0x0L;
  read_ct = 0x0L;
  write_ct = 0x0L;
  read_fl_ct = 0x0L;
  write_fl_ct = 0x0L;
  flush_ct = 0x0L;
  return success;
}


int cstats()
{
  stats();
  return clear_stats();
}


int stats()
{
  dprintf((diagout, "\n"));
  dprintf((diagout, "OPERATIONS SUMMARY:\n"));
  dprintf((diagout,
	 "\
            NEXT     PREV      GET      PUT      REM   GETENT   CACHE    CACHE\n"));
  dprintf((diagout,
	 "\
                                                                AVAIL?   VALID?\n"));
  dprintf((diagout,
	 "   succ %8lu %8lu %8lu %8lu %8lu %8lu %8lu %8lu\n",
	 next_ct,
	 prev_ct,
	 get_ct,
	 put_ct,
	 rem_ct,
	 ge_ct,
	 tge_ct,
	 tce_ct));
  dprintf((diagout,
	 "   fail %8lu %8lu %8lu %8lu %8lu %8lu %8lu %8lu\n\n",
	 next_fct,
	 prev_fct,
	 get_fct,
	 put_fct,
	 rem_fct,
	 ge_fct,
	 tge_fct,
	 tce_fct));
  dprintf((diagout, "INTERNAL OPERATIONS SUMMARY:\n"));
  dprintf((diagout, "   chains-to-next = %d\n", chains_to_next));
  dprintf((diagout,
	 "   %d block splits, %d deferred parent updates, %d undone\n",
	 block_splits,
	 deferred_inserts,
	 deferred_inserts));
  dprintf((diagout,
	 "   %d split index inserts; %d index-insert screw cases \n",
	 split_index_inserts,
	 index_screw_case));
  dprintf((diagout,
	 "   %d block deletes; %d deferred block deletes\n\n",
	 block_deletes,
	 deferred_deletes));
  dprintf((diagout,
	 "\
I/O SUMMARY: %lu READS, %lu WRITES, %lu FLUSH (of dirty bufs) calls.\n",
	 read_ct,
	 write_ct,
	 flush_ct));
  dprintf((diagout,
	 "             %lu FREELIST READS, %lu FREELIST WRITES.\n",
	 read_fl_ct,
	 write_fl_ct));
  dprintf((diagout, "             %lu DIRS LEFT DTY.\n", dir_dty_ct));
  {
    int ops = max((next_fct)+(prev_fct)+(get_fct)+(put_fct)+(rem_fct)+(next_ct)+(prev_ct)+(get_ct)
     +(put_ct)+(rem_ct), 1);
    dprintf((diagout,
	 "   AVG BLKS REFERENCED PER OPERATION: %7lu%%\n",
	 (0x64*((ge_ct)+(tce_ct)))/(ops)));
    dprintf((diagout, "   AVG DISK I/Os PER OPERATION: %7lu%%; ", (0x64*((read_ct)+(write_ct)+(read_fl_ct)+(write_fl_ct)))/(ops)));
    dprintf((diagout, "   WRITE/READ RATIO: %7lu%%\n", (0x64*((write_ct)+(write_fl_ct)))/(max(1, (read_ct)+(read_fl_ct)))));
    if ((put_ct)>0)
      dprintf((diagout, "   AVG DISK WRITES PER PUT: %7lu%%\n", (0x64*(write_ct))/(put_ct)));
  }
  dprintf((diagout, "\n"));
  dprintf((diagout, "MODES IN EFFECT:\n"));
  dprintf((diagout,
	 "\
%lu buffers [hashed over %d buckets]; blksize (max)=%d; FLC-LEN=%d\n",
	 num_ents_ct,
	 num_buks,
	 blk_size,
	 flc_len));
  dprintf((diagout,
	 "defer-insert-updates?= %2s; defer-block-deletes=%2s\n",
	 defer_insert_updates_P
	     ?"#t"
	     :"#f",
	 del_defer_block_deletes_P
	     ?"#t"
	     :"#f"));
  dprintf((diagout,
	 "cache-ent-enable?=%2s; clever-cache-enable=%2s\n",
	 cache_ent_enable_P
	     ?"#t"
	     :"#f",
	 clever_cache_enable
	     ?"#t"
	     :"#f"));
  dprintf((diagout, "\n"));
  return success;
}


void show_buffer(ent)
     ENTRY *ent;
{
  dprintf((diagout,
	 "SEG = %d ID= %lu ACC= %d REF= %d DTY= %d AGE= %d\n",
	 ent_seg(ent),
	 ent_id(ent),
	 ent_acc(ent),
	 ent_ref(ent),
	 ent_dty_P(ent),
	 ent_age(ent)));
}


int buf_verbose_P = !0;


int show_buffer_1(ent)
     ENTRY *ent;
{
  if ((buf_verbose_P)
      || ((ent_seg(ent))> -1))
    {
      dprintf((diagout, " %3d:%-6lu %6lu %8d %6u %7d %3d %4d", ent_seg(ent), ent_id(ent), hash2int(ent_seg(ent), ent_id(ent)), ent_acc(ent), ent_ref(ent), 0, ent_dty_P(ent), ent_age(ent)));
      if ((ent_seg(ent))> -1)
	{
	  dprintf((diagout, " %5d %4c\n", (blk_level(ent_blk(ent)))-(leaf), blk_typ(ent_blk(ent))));
	}
      else dprintf((diagout, "\n"));
    }
  return success;
}


int show_buffers()
{
  dprintf((diagout, "\n"));
  dprintf((diagout,
	 "\
 SEG:ID        BUK      ACC    REF READERS DTY  AGE LEVEL TYPE\n"));
  return do_seg_buffers( -1, show_buffer_1);
}


int sb()
{
  return show_buffers();
}
